use phf::phf_map;
use rocket::request::FromParam;

pub struct RequestLanguage {
    pub language: String,
}

static LANG_TO_CODES: phf::Map<&'static str, &'static str> = phf_map! {
    "cs" => "cs-CZ",
    "en" => "en-US",
};

impl<'r> FromParam<'r> for RequestLanguage {
    type Error = &'r str;

    fn from_param(param: &'r str) -> Result<Self, Self::Error> {
        match LANG_TO_CODES.get(param) {
            Some(val) => Ok(RequestLanguage {
                language: val.to_string(),
            }),
            None => Ok(RequestLanguage {
                language: LANG_TO_CODES["en"].to_string(),
            }),
        }
    }
}
